import { type BoundFunction, MiniSignalBinding } from './mini-signals-binding';
export declare class MiniSignal<T extends any[] = any[], A extends any | undefined = any | undefined> {
    private _head?;
    private _tail?;
    hasHandlers(): boolean;
    /**
     * Return an array of attached MiniSignalBinding.
     */
    handlers(): Array<MiniSignalBinding<T, A>>;
    /**
     * Return true if node is a MiniSignalBinding attached to this MiniSignal
     */
    has(node: MiniSignalBinding<T, A>): boolean;
    /**
     * Dispatches a signal to all registered listeners.
     */
    dispatch(...args: T): boolean;
    /**
     * Register a new listener.
     */
    add(fn: BoundFunction<T>, thisArg?: A): MiniSignalBinding<T, A>;
    /**
     * Register a new listener that will be executed only once.
     */
    once(fn: BoundFunction<T>, thisArg?: A): MiniSignalBinding;
    /**
     * Remove binding object.
     */
    detach(node: MiniSignalBinding<T, A>): this;
    /**
     * Detach all listeners.
     */
    detachAll(): this;
    private _addMiniSignalBinding;
}
